<?php
//===========================================================================
//                      Crafty Syntax Image gallery (CSIG)  
//                    http://www.craftysyntax.com/CSIG/ 
//                    Copyright (C) 2003-2004 Eric Gerdes  
//===========================================================================
//         $Id: imagelist.php,v 1.0 2004/04/07 03:17:40 csyntax Exp $
// --------------------------------------------------------------------------
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//===========================================================================

//config file
require_once 'config.php';

// settings for libraries paths PEAR/SMARTY/USER ACCESS.
require_once 'libraries.php';

// connect to database.
require_once 'database_connect.php';

// Begin User Access 
require_once 'ua.begin.php';

require("functions.php");

$smarty = new Smarty;

//Load the design vars.
$COLORSCHEME[init] = "init";
require "templates/design.php";


// only people with FULL permissions to this gallery can do this..
if($projectid == ""){ $projectid = 0; }
if(!(checkpermissions("FULL",$projectid,$user_id))){ 
print "<font color=990000>Access denied...</font>";
exit;
}

if($whattodo == "EDIT USER LIST"){
 Header("Location: users.php");
exit;	
}

// "DELETE GALLERY"
if($whattodo == "DELETE GALLERY"){
  $quer = "SELECT * FROM gallery_feature_list WHERE feature_id='$projectid'"; 	
  $rs = $db->query($quer);
  $mydata = $rs->fetchRow(DB_FETCHMODE_ASSOC);
 
  if($iamsure != "YES"){
  ?>
  <br><br>
  <h2>Are You sure you want to delete gallery: <?= $mydata[val] ?></h2>
  <br>
  <?
  }

  $query = "SELECT * FROM gallery,gallery_feature_xref WHERE gallery.recno=gallery_feature_xref.galleryid AND gallery_feature_xref.featureid='$projectid' ";
  $resul = $db->query($query);
  while($imagesin = $resul->fetchRow(DB_FETCHMODE_ASSOC)){
    $galleryid = $imagesin['recno']; 
    // see if the image in question is also part of a different gallery..
    $query = "SELECT * FROM gallery_feature_xref WHERE galleryid='$galleryid'";
    $res = $db->query($query);
    if($res->numrows() <2){
      $thumb = "userimages/" . substr($imagesin['thumb'],0,1) . "/" . $imagesin['thumb']; 
      $image = "userimages/" . substr($imagesin['image'],0,1) . "/" . $imagesin['image'];
      if($imagesin['high_res'] != ""){
      	 $high = "userimages/" . substr($imagesin['high_res'],0,1) . "/" . $imagesin['high_res'];
      } else { $high = ""; }
      $removed .= "<img src=$thumb >";
      if($iamsure == "YES"){
         print "removing.. $thumb $image $high<br>";
         unlink($thumb);
         unlink($image);
         $quer = "DELETE FROM gallery WHERE recno='$galleryid'"; 	
         $rs = $db->query($quer);
         if($high != ""){ unlink($high);  }
      }
    } else {
      $thumb = "userimages/" . substr($imagesin['thumb'],0,1) . "/" . $imagesin['thumb']; 
      $skipped .= "<img src=$thumb >";	
    }
  }
  if($iamsure != "YES"){
  if($removed != ""){
     print "<h3><font color=990000><b>These Images Will also be removed:</b></font></h3> <br> $removed <br><br> ";
  } 
  if($skipped != ""){ 
     print "<h3><font color=009900><b>These Images are part of this gallery but WILL NOT be deleted because they are a part of other galleries:</b></font></h3><br> $skipped ";  
  }
  print "<br><br><a href=javascript:history.go(-1)>No I am not sure.. do not delete.</a>";
  print "<bR><br><a href=features.php?iamsure=YES&projectid=$projectid&whattodo=DELETE+GALLERY>YES I AM SURE DELETE IT.</a>";  
} else {
   $quer = "DELETE FROM gallery_feature_list WHERE feature_id='$projectid'"; 	
   $rs = $db->query($quer);
   $quer = "DELETE FROM gallery_feature_xref WHERE featureid='$projectid'"; 	
   $rs = $db->query($quer);      
   print "Gallery has been removed...";	
  }
  exit;
}

// UPDATE-----------------------------------------
if($whattodo == "UPDATE"){
  $query = "UPDATE gallery_feature_list set val='$newval',ordernum='$newordering',description='$newdescription' WHERE feature_id='$projectid' ";
  $db->query($query);
  print "<h2>database updated.. </h2><a href=imagemenu.php?projectid=$projectid target=_top>click here</a>";
  exit;	
}

// INSERT GALLERY -------------------------------------
if($whattodo == "INSERT"){

  // add the gallery.
  $query = "INSERT INTO gallery_feature_list (val,ordernum,description,parentid) VALUES ('$newgalleryname','$ordering','$description','$parentid')";
  $db->query($query);

  // get the Id number.
  $quer = "SELECT feature_id FROM gallery_feature_list ORDER by feature_id DESC"; 	
  $rs = $db->query($quer);
  $mydata2 = $rs->fetchRow(DB_FETCHMODE_ASSOC);
  $feature_id = $mydata2['feature_id']; 
    
  // give this user permissions.
  $query = "INSERT INTO gallery_access (userid,galleryid,permissions) VALUES ('$user_id','$feature_id','FULL') ";
  $db->query($query);
  
  // now we want to show the edit.
  $whattodo = "EDIT";
  $projectid = $feature_id;
}

// "GIVE ACCESS"
if($whattodo == "GIVE ACCESS"){

  $query = "INSERT INTO gallery_access (userid,galleryid,permissions) VALUES ('$adduser','$projectid','READ') ";
  $db->query($query);
  
   // now we want to show the edit.
  $whattodo = "EDIT";	
}

// UPDATE PERMISSIONS -------------------------------------
if($whattodo == "UPDATE PERMISSIONS"){
   $query = "DELETE FROM gallery_access WHERE galleryid='$projectid'";
   $db->query($query);
   
   // do individual permissions.
   while (list($key, $val) = each($HTTP_POST_VARS)) {                
       $array = split("__",$key);
       if($array[0] == "permissions") {
       	  $permission = $array[1];
       	  $userid = $array[2];
       	  $query = "INSERT INTO gallery_access (userid,galleryid,permissions) VALUES ('$userid','$projectid','$permission') ";
          $db->query($query);          
       }
     }	

  $whattodo = "EDIT";
}
    


// CREATE MENU -------------------------------------
if($whattodo == "EDIT"){
  $quer = "SELECT * FROM gallery_feature_list WHERE feature_id='$projectid'"; 	
  $rs = $db->query($quer);
  $mydata = $rs->fetchRow(DB_FETCHMODE_ASSOC);

  ?>
  <center>
  <form action=features.php method=POST>
  <input type=hidden name=projectid value=<?= $projectid ?> >  
  <table>
  <tr><td colspan=4><b>Permissions for <?= $mydata[val] ?>:</b><br>
  <?
  $query = "SELECT * FROM gallery_users";
  $data_users = $db->query($query);
  ?>
  <table border=1><tr bgcolor=DDDDDD><td>Name</td><td>username</td><td>ACCESS</td><td>actions</td></tr>
  <?
  while($data_user = $data_users->fetchRow(DB_FETCHMODE_ASSOC)){  
     if(checkpermissions("WRITE",$projectid,$data_user[recno],1)){
    	$pwrite = " CHECKED ";
     } else { $pwrite = ""; }
     if(checkpermissions("READ",$projectid,$data_user[recno],1)){
    	$pread = " CHECKED ";
     } else { $pread = ""; }
    if(checkpermissions("READHIDDEN",$projectid,$data_user[recno],1)){
    	$preadhidden = " CHECKED ";
    } else { $preadhidden = ""; }
    if(checkpermissions("APPROVE",$projectid,$data_user[recno],1)){
    	$papprove = " CHECKED ";
    }  else { $papprove = ""; }
    if(checkpermissions("FULL",$projectid,$data_user[recno],1)){
    	$pfull = " CHECKED ";
    }  else { $pfull = ""; }     

    if(checkpermissions("FULL",0,$data_user[recno],1)){
    	$everything = " CHECKED ";
    }  else { $everything = ""; }     
    
    $access_any = $pfull . $papprove . $preadhidden . $pread . $pwrite;
    if($access_any != ""){
      if($bgcolor == "FFFFEE"){ $bgcolor= "EEEEDD"; } else { $bgcolor= "FFFFEE"; }
      if($data_user[recno] == 1){ 
        print "<tr><td colspan=2><font color=000077>EVERYONE:</font></td><td>";	
      } else {    
        print "<tr><td>$data_user[realname] </td><td>$data_user[username]</td><td>";
      }
      if($everything == ""){
      print "<input type=checkbox name=permissions__READ__" . $data_user[recno]  . "$pread value=1>READ <input type=checkbox name=permissions__READHIDDEN__" . $data_user[recno]  . " $preadhidden value=1>READ HIDDEN  <input type=checkbox name=permissions__WRITE__" . $data_user[recno]  . " $pwrite value=1>WRITE  <input type=checkbox name=permissions__APPROVE__" . $data_user[recno]  . " $papprove value=1>APPROVE <input type=checkbox name=permissions__FULL__" . $data_user[recno]  . " $pfull value=1>FULL ";
      } else {
      print "<font color=990000><b>Admin access.. Full permissions..</b></font>";
      }
      print "</td><td NOWRAP>";
      print "[<a href=users.php?edit=$data_user[recno]><font color=000099>EDIT</font></a>] ";
      print "</td>";
      print "</tr>";      	
     }
   } 
    ?>
    <tr><td colspan=4>
    <b>Existing Users:</b>
    <?
    $query = "SELECT * FROM gallery_users order by username";
    $rs3 = $db->query($query);
    if ($rs3->numrows() != 0){
    ?>
    <select name=adduser>
    <?
     print "<option value=1>-------------</option>\n";
     print "<option value=1>**EVERYONE:**</option>\n";
     while($data_users_d = $rs3->fetchRow(DB_FETCHMODE_ASSOC)){
        print "<option value=$data_users_d[recno]>$data_users_d[username] : $data_users_d[realname]</option>\n";
     }
    ?>
     </select>
     <input type=submit value="GIVE ACCESS" name=whattodo><br>
<? } else {
 print "<i>No Users have been added. Click</i> EDIT USER LIST <i>to add users</i>";	
}?>
<hr><input type="submit" name=whattodo value="EDIT USER LIST"> <input type="submit" name=whattodo value="UPDATE PERMISSIONS">
</td></tr></table></FORM>

<FORM ACTION=features.php METHOD=POST>
<input type=hidden name=projectid value=<?= $projectid ?> > 
<b>Gallery Information:</b>
<table>
<tr><td><b>Ordering: </b></td><td><input type=text size=4 name=newordering value=<?= $mydata['ordernum'] ?> ></td></tr>
<tr><td><b>Gallery Name:</b></td><td><input type=text size=20 name=newval value=<?= $mydata['val'] ?> ></td></tr>
<tr><td colspan=2><b>Description:</b><br>
<textarea cols=45 rows=5 name=newdescription><?= $mydata['description'] ?> </textarea>
</td></tr>
</table>
<input type=submit name=whattodo value=UPDATE> 
<br><br>
<? 
  $quer = "SELECT * FROM gallery_feature_list"; 	
  $rees = $db->query($quer);
if($rees->numrows() != 1){
?>
<input type=submit name=whattodo value="DELETE GALLERY"> 
<? } else { ?>
  [DELETE] - Because this is the Only gallery left you can not delete it.. <br>To delete this gallery you will need to add another gallery first then delete this one..
<? } ?>
</td></tr></table></center>
<?
}
	
// CREATE MENU -------------------------------------
if($whattodo == "CREATE"){
  ?>
    <h2>Create a new Gallery:</h2><br>
    <form action=features.php METHOD=POST>
    <input type=hidden name=parentid value=<?= $projectid ?> >
    <input type=hidden name=whattodo value=INSERT>    
    <table>
    <tr><td><b>Ordering Number:</b></td><td><input type=text name=newordering size=4></td></tr>
    <tr><td><b>Gallery Name:</b></td><td><input type=text name=newgalleryname></td></tr> 
    <tr><td colspan=2><b>Description:</b> (might not be used in template)<br>
    <textarea cols=45 rows=4 name=description></textarea></td></tr> 
    </table>
    <input type=submit value=next>
    </FORM>
  <?
}

?>