<?php
//===========================================================================
//                      Crafty Syntax Image gallery (CSIG)  
//                    http://www.craftysyntax.com/CSIG/ 
//                    Copyright (C) 2003-2004 Eric Gerdes  
//===========================================================================
//         $Id: index.php,v 1.0 2004/04/07 03:17:40 csyntax Exp $
// --------------------------------------------------------------------------
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//===========================================================================

//config file
require_once 'config.php';

// settings for libraries paths PEAR/SMARTY/USER ACCESS.
require_once 'libraries.php';

// connect to database.
require_once 'database_connect.php';

// Begin User Access 
require_once 'ua.begin.php';

require_once "functions.php";


function dopermissions($level,$user_id){
  global $myuser,$db,$projectid;
  $query = "SELECT * From gallery_feature_list where parentid='$level'";
  $rows = $db->getAll($query,DB_FETCHMODE_ASSOC);
  for($i=0;$i<count($rows);$i++){
    $mygallery = $rows[$i];
    if(checkpermissions("WRITE",$mygallery[feature_id],$user_id,1)){
    	$pwrite = " CHECKED ";
    } else { $pwrite = " "; }
    if(checkpermissions("READ",$mygallery[feature_id],$user_id,1)){
    	$pread = " CHECKED ";
    } else { $pread = " "; }
    if(checkpermissions("READHIDDEN",$mygallery[feature_id],$user_id,1)){
    	$preadhidden = " CHECKED ";
    } else { $preadhidden = " "; }
    if(checkpermissions("APPROVE",$mygallery[feature_id],$user_id,1)){
    	$papprove = " CHECKED ";
    }  else { $papprove = " "; }
    if(checkpermissions("FULL",$mygallery[feature_id],$user_id,1)){
    	$pfull = " CHECKED ";
    }  else { $pfull = " "; }     
    // see if there are any children.
    $query = "select * from gallery_feature_list WHERE parentid='$mygallery[feature_id]' order by ordernum,val";
    $rs_t = $db->query($query);  
    if($bgcolor == "FFFFEE"){ $bgcolor= "EEEEDD"; } else { $bgcolor= "FFFFEE"; }
    print "<table bgcolor=$bgcolor><tr><td width=150><b>" . $mygallery['val'] . "</b></td><td>" . " <input type=checkbox name=permissions__READ__" . $mygallery['feature_id']  . "$pread value=1>READ <input type=checkbox name=permissions__READHIDDEN__" . $mygallery['feature_id']  . " $preadhidden value=1>READ HIDDEN  <input type=checkbox name=permissions__WRITE__" . $mygallery['feature_id']  . " $pwrite value=1>WRITE  <input type=checkbox name=permissions__APPROVE__" . $mygallery['feature_id']  . " $papprove value=1>APPROVE <input type=checkbox name=permissions__FULL__" . $mygallery['feature_id']  . " $pfull value=1>FULL </td></tr></table>";
    if($rs_t->numrows() == 0){
      // do nothing...	
    } else {
       print "<ul>";
       dopermissions($mygallery[feature_id],$user_id);
       print "</ul>";
    }    
  }
}

$smarty = new Smarty;

//Load the design vars.
$COLORSCHEME[init] = "init";
require "templates/design.php";

if(!(checkpermissions("FULL",0,$user_id))){ 
print "<font color=990000>Access denied...</font>";
exit;
}

if($deleterec != ""){
  $query = "DELETE FROM gallery_access WHERE userid='$deleterec' ";
  $db->query($query);
  $query = "DELETE FROM gallery_fav WHERE userid='$deleterec' ";
  $db->query($query);
  $query = "DELETE FROM gallery_users WHERE recno='$deleterec' ";
  $db->query($query);    
}
if($whattodo == "UPDATE"){
    $query = "UPDATE gallery_users set realname='$realname',username='$newusername',password='$newpassword',emailadd='$emailadd' WHERE recno='$recno'";
    $db->query($query); 	
    $query = "DELETE FROM gallery_access WHERE userid='$recno'";
    $db->query($query);
    if ($isadmin != ""){
      $query = "INSERT INTO gallery_access (userid,galleryid,permissions) VALUES ('$recno','0','FULL') ";
      $db->query($query);      
    } else {
     // do individual permissions.
     while (list($key, $val) = each($HTTP_POST_VARS)) {                
       $array = split("__",$key);
       if($array[0] == "permissions") {
       	  $permission = $array[1];
       	  $gallery = $array[2];
       	  $query = "INSERT INTO gallery_access (userid,galleryid,permissions) VALUES ('$recno','$gallery','$permission') ";
          $db->query($query);
       }
     }	
    }
}

if($whattodo == "ADD"){
  //realname username password

    $query = "INSERT INTO gallery_users  (realname,username,password,emailadd,perpage) VALUES ('$realname','$newusername','$newpassword','$emailadd','15') ";
    $db->query($query); 	
            
    if($allowgallery == "A"){ 
    // get the userid
    $quer = "SELECT recno FROM gallery_users ORDER by recno DESC"; 	
    $rs = $db->query($quer);
    $mydata = $rs->fetchRow(DB_FETCHMODE_ASSOC);
    $userid = $mydata[recno]; 
    
      // get the next id number
     $quer = "SELECT feature_id FROM gallery_feature_list ORDER by feature_id DESC"; 	
     $rs = $db->query($quer);
     
     $mydata = $rs->fetchRow(DB_FETCHMODE_ASSOC);
     $recno = $mydata[feature_id];  
     if($recno == ""){ $recno = 2; }
     $recno++;
  
     // add it to database.
     $insert_q = "INSERT INTO gallery_feature_list (feature_id,val) VALUES ('$recno','$newusername') "; 	
     $db->query($insert_q);

     // add user permissions
      $query = "INSERT INTO gallery_access (userid,galleryid,permissions) VALUES ('$userid','$recno','F')";	
      $db->query($query);
  
     // add everyone permissions
     // $query = "INSERT INTO gallery_access (userid,galleryid,permissions) VALUES ('1','$recno','R')";	
     // $db->query($query);
    }

}


?><body background=<? print "$framebackground"; ?> ><?

print "<center>";
  
$query = "select * from gallery_users order by lastin DESC";
$rs = $db->query($query);
print "<br><b>Current User Access List:</b><br>";
print "<table width=400 bgcolor=ffffcc><tr><td  bgcolor=ffff99>Name</td><td bgcolor=ffff99>last log in.<img src=../userimages/blank.gif width=150 height=1></td><td bgcolor=ffff99>visits</td><td bgcolor=ffff99>Access</td><td>options</td></tr>";
$bgcolor = "FFFFEE";
while($myrow = $rs->fetchRow(DB_FETCHMODE_ASSOC)){
 if($bgcolor == "FFFFEE") { $bgcolor = "FFFFDD"; } else { $bgcolor = "FFFFEE"; }

$date = substr($myrow[lastin],4,2) . "-" . substr($myrow[lastin],6,2) . "-" . substr($myrow[lastin],0,4) . " ( " . substr($myrow[lastin],8,2) . ":" . substr($myrow[lastin],10,2) . ":" . substr($myrow[lastin],12,2) . ")";
if($edit != $myrow[recno]){
if($myrow[recno]!= 1){
  print "<tr bgcolor=$bgcolor><td>$myrow[username]</td><td>$date</td><td>$myrow[visits]</td>"; 
} else {
  print "<tr bgcolor=$bgcolor><td><font color=007700><b>GUEST USER</b></font></td><td>$date</td><td>$myrow[visits]</td>";  
}
print "<td>";
$query = "select * from gallery_access WHERE galleryid='0' and userid='$myrow[recno]' ";
$rs2 = $db->query($query);
if($rs2->numrows() != 0){ print "<b>FULL ACCESS</b>";  }
 print "</td>";
 print "<td NOWRAP><a href=users.php?edit=$myrow[recno]>edit</a> ";
 if($myrow[recno] != 1){
   print "<a href=users.php?deleterec=$myrow[recno] onClick=\"return confirm('Are you sure you want to Remove $myrow[username]??')\"><font color=990000>delete</font></a>  <a href=people.php?userid=$myrow[recno]></a>";
 }
 print "</td></tr>";
} else {
$query = "select * from gallery_access WHERE galleryid='0' and userid='$myrow[recno]' ";
$rs2 = $db->query($query);
if($rs2->numrows() != 0){ $isadmin = " CHECKED "; } else { $isadmin = ""; }
	?>
	<tr><td colspan=8 align=center>
<b>UPDATE an Existing  user:</b>
<form action=users.php method=post>
<input type=hidden name=recno value=<?= $myrow[recno] ?>>

<? 
if($myrow[recno] ==1){ 
  
  print "<input type=hidden name=newusername value=guest_user>";
  print "<h2><b>Guest User:</b> </h2> This is the user permissions for Guest users or users who have not logged in<br><br>";
	
} else { ?>
<table>
<tr><td><b>Real Name:</b></td><td align=left><input type=text size=20 name=realname value="<?= $myrow[realname] ?>" ></td></tr>
<tr><td><b>e-mail address:</b></td><td align=left><input type=text size=20 name=emailadd value="<?= $myrow[emailadd] ?>" ></td></tr>
<tr><td><b>username:</b></td><td align=left><input type=text size=20 name=newusername value="<?= $myrow[username] ?>" ></td></tr>
<tr><td><b>password:</b></td><td align=left><input type=text size=20 name=newpassword value="<?= $myrow[password] ?>" ></td></tr>
</table>
<? } ?>
<b>Gallery Permissions:</b><center>
<table width=600>
<tr bgcolor=DDDDDD><td width=150><b>Gallery</b></td><td width=450><b>Permissions:</b></td></tr>
<? if($myrow[recno] !=1){ ?>
	<tr><td colspan=2><center><b><font color=990000>FULL WRITE/ADMIN ACCESS:</font></b> <input type=checkbox name=isadmin value="Y" <?= $isadmin ?>></center></td></tr>
<? } ?>
<tr><td colspan=2>
<?
 dopermissions(0,$myrow[recno]);
?>
</td></tr>
</table>
<input type=submit value=UPDATE name=whattodo>
</form></center>	</td></tr>
<?
}

}
print "</table>";
print "</td></tr></table>";
?>
<br>
<b>ADD a new user:</b>
<form action=users.php method=post>
<table>
<tr><td><b>Real Name:</b></td><td><input type=text size=20 name=realname></td></tr>
<tr><td><b>e-mail address:</b></td><td><input type=text size=20 name=emailadd></td></tr>
<tr><td><b>username:</b></td><td><input type=text size=20 name=newusername></td></tr>
<tr><td><b>password:</b></td><td><input type=text size=20 name=newpassword></td></tr>
</table>
<input type=submit value=ADD name=whattodo>
</form>