<?php
//===========================================================================
//                      Crafty Syntax Image gallery (CSIG)  
//                    http://www.craftysyntax.com/CSIG/ 
//                    Copyright (C) 2003-2004 Eric Gerdes  
//===========================================================================
//         $Id: imagelist.php,v 1.0 2004/04/07 03:17:40 csyntax Exp $
// --------------------------------------------------------------------------
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//===========================================================================

//config file
require_once 'config.php';

// settings for libraries paths PEAR/SMARTY/USER ACCESS.
require_once 'libraries.php';

// connect to database.
require_once 'database_connect.php';

// Begin User Access 
require_once 'ua.begin.php';

require("functions.php");

//Load the design vars.
require "templates/design.php";

if(!(checkpermissions("FULL",0,$user_id))){ 
print "<font color=990000>Access denied...</font>";
exit;
}


// UPDATE a LAYOUT ---------------------------------------------
if ($whattodo == "UPDATE"){
  //delete the old one.
  $query = "DELETE FROM gallery_colorscheme WHERE colorchoice='$oldcolorchoice'";
  $db->query($query);
  // insert the new one.. 
  $whattodo = "INSERT";
}

// REMOVE a LAYOUT
if ($whattodo == "REMOVE"){
  $query = "DELETE FROM gallery_colorscheme WHERE colorchoice='$removewhatcolor'";
  $db->query($query);
  $whattodo = "";
}

// CREATE A new LAYOUT -----------------------------------------
if ($whattodo == "INSERT"){
 // check to make sure it is not null
 if($newcolorchoice == ""){ $newcolorchoice = "no_name"; }
 // convert spaces to _
 $newcolorchoice = ereg_replace(" ","_",$newcolorchoice);
 //check to make sure  that the newcolorchoice does not already exist
 $query = "SELECT * FROM gallery_colorscheme WHERE colorchoice='$newcolorchoice'";
 $rs_check = $db->query($query);
 $j = 0;
 while($rs_check->numrows() != 0){
    $j++;
    $newcolorchoice = $newcolorchoice . $j;
    $query = "SELECT * FROM gallery_colorscheme WHERE colorchoice='$newcolorchoice'";
    $rs_check = $db->query($query);
 }
 // insert the values pairs.. 
 $valuefound = true; // if we found a value..
 $i = 0; 
 while($i<50){
   $i++;
   $keyname = "key_" . $i;
   $valname = "val_" . $i;
   $key = $$keyname;
   $val = $$valname;
   if($key == ""){ 
     $valuefound = false; 
   } else {
    $query = "INSERT INTO gallery_colorscheme (colorchoice,mykey,myval) values ('$newcolorchoice','$key','$val')";
    $db->query($query);
   }
 }
// reset to show listing.. 
$whattodo = "";
}

// EDIT AN EXISTING COLOR SCHEME--------------------------------------------
if($whattodo == "EDIT"){
 $query = "SELECT * FROM gallery_colorscheme WHERE colorchoice='$editwhatcolor'";
 $rs2 = $db->query($query);
 print "<h2>Edit color layout:</h2><br><form action=colorchoices.php method=POST name=newmenu><input type=hidden name=whattodo value=UPDATE>";
 print "<table width=500 bgcolor=FFFFEE><tr><td>Enter in the variable subsitutions for the new color layout.</td></tr></table>";
 print "<b>Color Name:</b><input type=text name=newcolorchoice size=20 value=$editwhatcolor><input type=hidden name=oldcolorchoice size=20 value=$editwhatcolor><br>";
 print "<table>";
 $i=0;
 while($row = $rs2->fetchRow(DB_FETCHMODE_ASSOC)){
    $i++;
    print "<tr><td><b>Variable: ";
    if($row[mykey] != "imagecell"){
       print "<input name=key_$i type=text size=30 maxsize=30 value=\"$row[mykey]\">";    
    } else {	 
       print "<b>$row[mykey]</b> (border around images)<input name=key_$i type=hidden size=30 maxsize=30 value=\"$row[mykey]\">";  
    }  
    print "</td> <td> <b>Value:</b> <input name=val_$i type=text size=40 maxsize=255 value=\"$row[myval]\" ></td>";
    print "<td><select name=changeto_$i onChange=\"document.newmenu.val_$i.value=document.newmenu.changeto_$i.value;\">\n";
    $query = "SELECT DISTINCT myval FROM gallery_colorscheme WHERE mykey='$row[mykey]'";
    $rs3 = $db->query($query);
    print "<option value=\"\">- existing values -</option>";
    while($row2 = $rs3->fetchRow(DB_FETCHMODE_ASSOC)){
    print "<option value=\"$row2[myval]\">$row2[myval]</option>";
    }
    print "</select></td></tr>\n";    
    
 }
 $i++;
 for($j=$i;$j<$i+3;$j++){
    print "<tr><td><b>Variable: <input name=key_$j type=text size=30 maxsize=30></td> <td> <b>Value:</b> <input name=val_$j type=text size=40 maxsize=255 ></td></tr>"; 
 }

 print "</table>";
 print "<input type=submit value=UPDATE name=whattodo></form>";	
}

// FORM TO CREATE A new COLOR SCHEME--------------------------------------------
if($whattodo == "CREATE"){
 // get all of the keys from the last design..
 $query = "SELECT DISTINCT mykey FROM gallery_colorscheme";
 $rs2 = $db->query($query);
 print "<h2>Create a New color layout:</h2><br><form action=colorchoices.php method=POST name=newmenu><input type=hidden name=whattodo value=INSERT>";
 print "<table width=500 bgcolor=FFFFEE><tr><td>Enter in the variable subsitutions for the new color layout that you will be creating.</td></tr></table>";
 print "<b>Color Name:</b><input type=text name=newcolorchoice size=20><br>";
 print "<table>";
 $i=0;
 while($row = $rs2->fetchRow(DB_FETCHMODE_ASSOC)){
    $i++;
    print "<tr><td><b>Variable: ";
    if($row[mykey] != "imagecell"){
       print "<input name=key_$i type=text size=30 maxsize=30 value=\"$row[mykey]\">";    
    } else {	 
       print "<b>$row[mykey]</b> (border around images)<input name=key_$i type=hidden size=30 maxsize=30 value=\"$row[mykey]\">";  
    }     
    print "</td> <td> <b>Value:</b> <input name=val_$i type=text size=40 maxsize=255></td>\n";
    print "<td><select name=changeto_$i onChange=\"document.newmenu.val_$i.value=document.newmenu.changeto_$i.value;\">\n";
    $query = "SELECT DISTINCT myval FROM gallery_colorscheme WHERE mykey='$row[mykey]'";
    $rs3 = $db->query($query);
    print "<option value=\"\">- existing values -</option>";
    while($row2 = $rs3->fetchRow(DB_FETCHMODE_ASSOC)){
    print "<option value=\"$row2[myval]\">$row2[myval]</option>";
    }
    print "</select></td></tr>\n"; 
    
 }
 $i++;
 for($j=$i;$j<$i+3;$j++){
    print "<tr><td><b>Variable: <input name=key_$j type=text size=30 maxsize=30></td> <td> <b>Value:</b> <input name=val_$j type=text size=40 maxsize=255 ></td></tr>"; 
 }

 print "</table>";
 print "<input type=submit value=CREATE name=nothing></form>";	
}

//SHOW LIST OF SCHEMES--------------------------------------------
if($whattodo == ""){
  ?><body bgcolor=FFFFFF><?
  print "<center><h2>Existing Color Schemes:</h2>";
  ?><table><tr bgcolor=dddddd><td>Color Name</td><td> actions:</td></tr><?  
  $query = "select DISTINCT colorchoice from gallery_colorscheme";
  $rs = $db->query($query);
  $numrows = $rs->numrows();
  while($row = $rs->fetchRow(DB_FETCHMODE_ASSOC)){
    if($bgcolor == "FFFFEE"){ $bgcolor = "FFFFCC"; } else { $bgcolor = "FFFFEE"; }
    ?><tr bgcolor=<?= $bgcolor ?>><td><b><?= $row[colorchoice] ?></b></td><td> [<a href=colorchoices.php?whattodo=EDIT&editwhatcolor=<?= $row[colorchoice] ?> >edit</a>]
    <? if ($numrows > 1){ ?> [<a href=colorchoices.php?whattodo=REMOVE&removewhatcolor=<?= $row[colorchoice] ?>><font color=990000>delete</font></a>]
    <? } ?></td></tr>
<? } ?>
  </table>
  <br><bR>
  <a href=colorchoices.php?whattodo=CREATE>CREATE A new COLOR CHOICE</a>
<? } ?>