<?php
function get_dir_size($dir) { 
$dh = opendir($dir);

while (($file = readdir($dh)) !== false) 
if ($file != "." and $file != "..")
	{ 
	$path = $dir."/".$file; 

	if (is_dir($path))
		{
		$size += get_dir_size($path); 
		}
		elseif (is_file($path)) 
		{
		$size += filesize($path); 
		}
} 
closedir($dh); 
return $size; 
}
function get_dir_list($dir){
	$dir_list=array();
	$file_list=array();
	$dir_array=array();

	$handle=opendir($dir);
	while($file=readdir($handle)){
	if ($file!="." && $file!="..")
		{
		if (is_dir("$dir/$file"))
			{
			array_push($dir_list,$file);
			}
		elseif (is_file("$dir/$file"))
			{
			array_push($file_list,$file);
			}
		}
	}
	asort($dir_list);
	asort($file_list);
	while (list ($key, $val) = each ($dir_list)) {
	array_push($dir_array,$val);
	}
	while (list ($key, $val) = each ($file_list)) {
	array_push($dir_array,$val);
	}
return $dir_array;
}
function get_file_date($file){
	$file_date=filemtime($file);
	clearstatcache();
	$file_date=date("Y-m-d H:i",$file_date);
return $file_date;
}

function get_file_size($file){
	$file_size=filesize($file);
	clearstatcache();
	if ($file_size >=1073741824) { 
	$file_size=ceil($file_size/1073741824100)." GB"; 
	} elseif ($file_size>=1048576) { 
	$file_size=ceil($file_size/1048576)." MB"; 
	} elseif ($file_size>=1024) { 
	$file_size=ceil($file_size/1024)." KB"; 
	} else { 
	$file_size=$file_size." Bytes"; 
	} 
return $file_size;
}
function get_file_type($file){
global $icon_php;
global $icon_asp;
global $icon_php;
global $icon_zip;
global $icon_html;
global $icon_text;
global $icon_audio;
global $icon_video;
global $icon_image;
$icon_cgi2=explode(" ",$icon_cgi);
$icon_asp2=explode(" ",$icon_asp);
$icon_php2=explode(" ",$icon_php);
$icon_zip2=explode(" ",$icon_zip);
$icon_html2=explode(" ",$icon_html);
$icon_text2=explode(" ",$icon_text);
$icon_audio2=explode(" ",$icon_audio);
$icon_video2=explode(" ",$icon_video);
$icon_image2=explode(" ",$icon_image);

$file_exet=strrchr($file,".");
$file_exet=strtolower($file_exet);
if (in_array($file_exet,$icon_html2))
	{
	$file_type="html";
	}
	elseif(in_array($file_exet,$icon_text2))
	{
	$file_type="text";
	}
	elseif(in_array($file_exet,$icon_audio2))
	{
	$file_type="audio";
	}
	elseif(in_array($file_exet,$icon_video2))
	{
	$file_type="video";
	}
	elseif(in_array($file_exet,$icon_image2))
	{
	$file_type="image";
	}
	elseif(in_array($file_exet,$icon_zip2))
	{
	$file_type="zip";
	}
	elseif(in_array($file_exet,$icon_cgi2))
	{
	$file_type="cgi";
	}
	elseif(in_array($file_exet,$icon_asp2))
	{
	$file_type="asp";
	}
	elseif(in_array($file_exet,$icon_php2))
	{
	$file_type="php";
	}
	else
	{
	$file_type="unknown";
	}
return $file_type;
}
function Jump_To_Dir($sPath) 
{ 
global $root_dir;
$handle=opendir($sPath); 
while ($file = readdir($handle)) { 
	$retVal[count($retVal)] = $file; 
	} 
closedir($handle); 
sort($retVal); 
while (list($key, $val) = each($retVal)) { 
	if ($val != "." && $val != "..") 
		{ 
		$path = str_replace("//","/",$sPath.$val); 
		if (is_dir($path))
			{
			$subpath=substr($path,strlen("$root_dir"),strlen($path)-strlen($root_dir));
			 echo "<option value=\"$subpath\">$subpath</option>\n"; 
			}
			if (is_dir($sPath.$val)) 
			{ 
			Jump_To_Dir($sPath.$val."/"); 
			} 
		} 
	} 
}
?>