<?php
//===========================================================================
//                      Crafty Syntax Image gallery (CSIG)  
//                    http://www.craftysyntax.com/CSIG/ 
//                    Copyright (C) 2003-2004 Eric Gerdes  
//===========================================================================
//         $Id: index.php,v 1.0 2004/04/07 03:17:40 csyntax Exp $
// --------------------------------------------------------------------------
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//===========================================================================

//config file
require_once 'config.php';

// settings for libraries paths PEAR/SMARTY/USER ACCESS.
require_once 'libraries.php';

// connect to database.
require_once 'database_connect.php';

// Begin User Access 
require_once 'ua.begin.php';


require("functions.php");

$smarty = new Smarty;

//Load the design vars.
$COLORSCHEME[init] = "init";
require "templates/design.php";

// get the template that we will be showing.
// if no template is selected then use logic.
if($html == ""){ 
  // if the project selected contains children show the menu template 
  // if not show the display template. 
  $query = "SELECT * FROM gallery_feature_list WHERE parentid='$projectid'";
  $rs = $db->query($query);
  if($rs->numrows() == 0){   
    Header("Location: imagelist.php?projectid=$projectid");
    exit;    
  } else {	
    $html = "default.tpl";        
  }   
}

if( ($usepage != "") && ($page != "")){
$file = "$style/$page";
} else {
$file = "$style/$html";	
}


// now replace out all of the vars...
//----------------------------------------------------------------
include "common.php";


//galleryimagemenu - build an array of associative array galleries.
// $gallerythumbs

$results_grouped = array();
$query = "select * from gallery_feature_list where parentid='$projectid' order by ordernum";
$rs= $db->query($query);  
$count =0;
while($row = $rs->fetchRow(DB_FETCHMODE_ASSOC)){   
     $query = "SELECT * FROM gallery,gallery_feature_xref WHERE gallery.approved!='Y' AND gallery.recno=gallery_feature_xref.galleryid AND gallery_feature_xref.featureid = '" . $row[feature_id] . "' order by RAND()";     
     $rs2 = $db->query($query); 
     $hidden = $rs2->numrows(); 
     
     $query = "SELECT * FROM gallery,gallery_feature_xref WHERE gallery.approved='Y' AND gallery.recno=gallery_feature_xref.galleryid AND gallery_feature_xref.featureid = '" . $row[feature_id] . "' order by RAND()";       
     $rs2 = $db->query($query); 
     $visable = $rs2->numrows(); 

     $p_data = $rs2->fetchRow(DB_FETCHMODE_ASSOC);
     $query = "SELECT * from gallery_feature_list where feature_id='$row[feature_id]'";
     $rs3 = $db->query($query);
     $data_w = $rs3->fetchRow(DB_FETCHMODE_ASSOC);
     $display = str_replace("_"," ",$data_w[val]);
     $url = "<a href=imagemenu.php?projectid=$row[feature_id] class=blackB target=_top>";     
     if ($p_data[thumb] == ""){
        $findthumb = lookforthum($row[feature_id]);
        if($findthumb == -1){  
        	 $thumb = "<img src=userimages/ni.gif width=90 height=75 border=0>"; 
        } else {
         $init1 = substr($findthumb,0,1);	 
         $filename = "$dirpath/$init1/$findthumb";       
         if(file_exists($filename)){
           $imageInfo = getimagesize($filename); 
           $width = $imageInfo[0]; 
           $height = $imageInfo[1];  
         }
         if($width > 100){ $width=100; }
         $thumb = "<img src=userimages/$init1/$findthumb width=$width height=75 border=0>";             	
        }
     } else {
       $init1 = substr($p_data[thumb],0,1);	 
       $filename = "$dirpath/$init1/$p_data[thumb]";
       if(file_exists($filename))
         $info = stat($filename);
         
       if($info[7] != 0){ 
         $imageInfo = getimagesize($filename); 
       }
       $width = $imageInfo[0]; 
       $height = $imageInfo[1];  
       if($width > 100){ $width=100; }
          $thumb = "<img src=userimages/$init1/$p_data[thumb] width=$width height=75 border=0>"; 
     }      
     $has_cats = has_cats($row[feature_id]);
     if($has_cats == 0){      	
        $visablephotos = $visable;
        $user_id = $myuser->getval("USER_ID");
        if(checkpermissions("READHIDDEN",$row[feature_id],$user_id)){
           if($hidden != 0){ $hiddenphotos = $hidden; } else { $hiddenphotos = 0; }
        }
     } else { 
        $numgalleries .= $galleries;
     } 

    $user_id = $myuser->getval("USER_ID");    
    if(checkpermissions("READHIDDEN",$row[feature_id],$user_id)){    
        $hidden_privligies = "YES";
    } else {
        $hidden_privligies = "NO";
    }

    if(checkpermissions("WRITE",$row[feature_id],$user_id)){    
        $write_privligies = "YES";
    } else {
        $write_privligies = "NO";
    }

    if(checkpermissions("EDIT",$row[feature_id],$user_id)){    
        $edit_privligies = "YES";
    } else {
        $edit_privligies = "NO";
    }
    
       
    if(checkpermissions("READ",$row[feature_id],$user_id)){	
    $results_grouped[$count] = array ( 
             'url'=>$url, 
             'id'=>$row[feature_id],
             'numgalleries'=>$numgalleries, 
             'hiddenphotos'=>$hiddenphotos,
             'thumbnail'=>$thumb,
             'width'=>$width,
             'visablephotos'=>$visablephotos,
             'display'=>$display,
             'hidden_privligies'=>$hidden_privligies,
             'write_privligies'=>$write_privligies,
             'edit_privligies'=>$edit_privligies
             );
    $count++;
    } // if has access
} // while loop
$smarty->assign("gallery_menu",$results_grouped);

$smarty->display($file);

?>