<?php
//===========================================================================
//                      Crafty Syntax Image gallery (CSLH)  
//                    http://www.craftysyntax.com/CSIG/ 
//                    Copyright (C) 2003-2004 Eric Gerdes  
//===========================================================================
//         $Id: libraries.php,v 1.0 2004/04/07 03:17:40 csyntax Exp $
// --------------------------------------------------------------------------
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//===========================================================================

 

// some ISPs run PHP in safe mode .. which disallows 
// a lot of things.. if this is turned on there is a 
// good chance that this gallery will not work.. but I will try.. 
$using_save_mode = ini_get("safe_mode");



if(!($use_server_PEAR)){
// alter the libraries include path to include the local library path.
// needed because a lot of the includes in the PEAR assume a library path to it is set....
$new_include_dir = "./:" . $root_path . "libraries/:" . ini_get('include_path');
ini_set('include_path', $new_include_dir);
}

//GLOBALS
require_once 'libraries/globals.php';

// PEAR Libraries
if($use_server_PEAR){
 require_once 'DB.php';
 require_once 'System.php';
 require_once 'System/Command.php';
 require_once 'Image/Transform.php';
} else {
 require_once 'libraries/DB.php';	
 require_once 'libraries/System.php';
 require_once 'libraries/System/Command.php';
 require_once 'libraries/Image/Transform.php';
}

// SMARTY:
if($use_server_SMARTY){
 require_once 'Smarty/libs/Smarty.class.php';
} else {
 require_once 'libraries/Smarty/libs/Smarty.class.php';  
}  


// USER ACCESS:
require_once 'ua.config.php';
require_once 'libraries/UA/ua.class.php';


?>